package example.android.bindservicesample;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;

public class BindServiceSampleActivity extends Activity {
    // T[rXɘAgC^[tF[X
    private BindServiceAIDL bindserviceIf = null;
    // ڑIuWFNg
    private ServiceConnection conn = null;
    
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.bindservicesample);
        
        // Jn{^IuWFNgɃNbNXi[ݒ
        Button startButton=(Button)findViewById(R.id.startButton);
        startButton.setOnClickListener(new StartButtonClickListener());
        
        // I{^IuWFNgɃNbNXi[ݒ
        Button stopButton=(Button)findViewById(R.id.stopButton);
        stopButton.setOnClickListener(new StopButtonClickListener());
    }
    
    // Jn{^NbNXi[`
    class StartButtonClickListener implements OnClickListener {
        // onClick\bh({^NbNCxg)
        public void onClick(View v) {   
            // bZ[W\
            Toast.makeText(BindServiceSampleActivity.this,
			            "T[rXJn܂", 
			            Toast.LENGTH_SHORT).show();
        	
            // Ceg
            Intent intent = new Intent(BindServiceAIDL.class.getName());

            // ServiceڑEؒfpIuWFNg
            conn = new SampleServiceConnection();

            // T[rXɃoCh
            bindService(intent, conn, BIND_AUTO_CREATE);
        }
    }
    
    // I{^NbNXi[`
    class StopButtonClickListener implements OnClickListener {
        // onClick\bh({^NbNCxg)
        public void onClick(View v) {    
            try {
            	// ANeBreBɘAgC^[tF[X
            	bindserviceIf.unregisterCallback(bindactivityIf);
            }catch(RemoteException e) {
                Log.e("ERROR", e.getMessage());
            }
            
            // bZ[W\
            Toast.makeText(BindServiceSampleActivity.this,
			            "T[rXI܂", 
			            Toast.LENGTH_SHORT).show();
            
            // T[rXAoCh
            unbindService(conn);
            // Ceg
            Intent intent = new Intent(BindServiceAIDL.class.getName());
            // T[rX~
            stopService(intent);
        }
    }
    
    // T[rXڑEڑNX`
    class SampleServiceConnection implements ServiceConnection {
    	// onServiceConnected\bh(ڑCxgnh)
        public void onServiceConnected(ComponentName compName, IBinder binder) {
            // T[rXƘAgC^[tF[X擾
        	bindserviceIf = BindServiceAIDL.Stub.asInterface(binder);
            try {
                // ANeBreBɘAgC^[tF[Xo^
            	bindserviceIf.registerCallback(bindactivityIf); 
            }catch (RemoteException e) {
                Log.e("ERROR", e.getMessage());
            }
        }
        // onServiceDisconnected\bh(ؒfCxgnh)
        public void onServiceDisconnected(ComponentName arg0) {
        	bindserviceIf = null;
        }
    }
    
    // ANeBreBɘAgC^[tF[XIuWFNg
    private BindActivityAIDL bindactivityIf = new BindActivityAIDL.Stub() {
        @Override
        public void displayTime(String msg) throws RemoteException {
            // handlerɃbZ[W𑗐M
            handler.sendMessage(Message.obtain(handler, 0, msg)); 
        }
    };     
    
    // nh[
    private Handler handler = new Handler(){ 
    	// bZ[W\
        public void handleMessage(Message msg) {
        	Toast.makeText(BindServiceSampleActivity.this,
				           (String)msg.obj, 
				            Toast.LENGTH_SHORT).show();   
        }
    };
}