package example.android.servicemondai2;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.os.RemoteException;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class ServiceMondai2Activity extends Activity {
    // T[rXɘAgC^[tF[X
    private ServiceAIDL bindserviceIf = null;
    // ڑIuWFNg
    private ServiceConnection conn = null;
    
    // onCreate\bh(ʏ\Cxgnh)
    @Override
    public void onCreate(Bundle savedInstanceState) {
        // X[p[NXonCreate\bhĂяo
        super.onCreate(savedInstanceState);
        // CAEgݒt@C̎w
        setContentView(R.layout.servicemondai2);
        
        // Jn{^IuWFNgɃNbNXi[ݒ
        Button startButton=(Button)findViewById(R.id.startButton);
        startButton.setOnClickListener(new StartButtonClickListener());
        
        // I{^IuWFNgɃNbNXi[ݒ
        Button stopButton=(Button)findViewById(R.id.stopButton);
        stopButton.setOnClickListener(new StopButtonClickListener());
        
        // Zbg{^IuWFNgɃNbNXi[ݒ
        Button resetButton=(Button)findViewById(R.id.resetButton);
        resetButton.setOnClickListener(new ResetButtonClickListener());
    }
    
    // Start{^NbNXi[`
    class StartButtonClickListener implements OnClickListener {
        // onClick\bh({^NbNCxg)
        public void onClick(View v) {          	
            // Ceg
            Intent intent = new Intent(ServiceAIDL.class.getName());

            // ServiceڑEؒfpIuWFNg
            conn = new SampleServiceConnection();

            // T[rXɃoCh
            bindService(intent, conn, BIND_AUTO_CREATE);
        }
    }
    
    // Stop{^NbNXi[`
    class StopButtonClickListener implements OnClickListener {
        // onClick\bh({^NbNCxg)
        public void onClick(View v) {    
            try {
            	// T[rXꎞ~
            	bindserviceIf.stopService();
            }catch(RemoteException e) {
                Log.e("ERROR", e.getMessage());
            }
        }
    }
    
    // Reset{^NbNXi[`
    class ResetButtonClickListener implements OnClickListener {
        // onClick\bh({^NbNCxg)
        public void onClick(View v) {    
            try {
            	// ANeBreBɘAgC^[tF[X
            	bindserviceIf.resetService(bindactivityIf);
            }catch(RemoteException e) {
                Log.e("ERROR", e.getMessage());
            }
            
            // T[rXAoCh
            unbindService(conn);
            // Ceg
            Intent intent = new Intent(ServiceAIDL.class.getName());
            // T[rX~
            stopService(intent);
        }
    }
    
    // T[rXڑEڑNX`
    class SampleServiceConnection implements ServiceConnection {
    	// onServiceConnected\bh(ڑCxgnh)
        public void onServiceConnected(ComponentName compName, IBinder binder) {
            // T[rXƘAgC^[tF[X擾
        	bindserviceIf = ServiceAIDL.Stub.asInterface(binder);
            try {
                // ANeBreBɘAgC^[tF[Xo^
            	bindserviceIf.startService(bindactivityIf); 
            }catch (RemoteException e) {
                Log.e("ERROR", e.getMessage());
            }
        }
        // onServiceDisconnected\bh(ؒfCxgnh)
        public void onServiceDisconnected(ComponentName arg0) {
        	bindserviceIf = null;
        }
    }
    
    // ANeBreBɘAgC^[tF[XIuWFNg
    private ActivityAIDL bindactivityIf = new ActivityAIDL.Stub() {
        @Override
        public void displayTime(String time) throws RemoteException {
            // handlerɃbZ[W𑗐M
            handler.sendMessage(Message.obtain(handler, 0, time)); 
        }
    };     
    
    // nh[
    private Handler handler = new Handler(){ 
    	// bZ[W\
        public void handleMessage(Message msg) {
    		// TextViewɎԂ\
    		TextView timetext = (TextView)findViewById(R.id.timetext);
    		timetext.setText((String)msg.obj);        	
        }
    };
}